<!--
  -    Copyright (c) 2018-2025, lengleng All rights reserved.
  -
  - Redistribution and use in source and binary forms, with or without
  - modification, are permitted provided that the following conditions are met:
  -
  - Redistributions of source code must retain the above copyright notice,
  - this list of conditions and the following disclaimer.
  - Redistributions in binary form must reproduce the above copyright
  - notice, this list of conditions and the following disclaimer in the
  - documentation and/or other materials provided with the distribution.
  - Neither the name of the pig4cloud.com developer nor the names of its
  - contributors may be used to endorse or promote products derived from
  - this software without specific prior written permission.
  - Author: lengleng (wangiegie@gmail.com)
  -->
<template>
  <div class="execution">
    <div class="startTime" style="display: inline-block">
      <span class="timeText" style="font-weight: bold;font-size: 14px">&#12288;起始时间:</span>
      <el-date-picker
        v-model="createDate"
        :clearable="false"
        type="date"
        value-format="timestamp"
        placeholder="选择日期">
      </el-date-picker>
    </div>
    <div style="display: inline-block">
      <span style="font-weight: bold;font-size: 14px">&#12288;场站名称：</span>
      <el-select style="width:250px" clearable v-model="stationCode" size="small">
        <el-option
          v-for="item in stationList"
          :key="item.value"
          :label="item.label"
          :value="item.value">
          <span style="float: left">{{ item.label }}</span>
          <span style="float: right; color: #8492a6;font-size: 13px">{{ item.value }}</span>
        </el-option>
      </el-select>
      &nbsp;
      <span style="font-weight: bold;font-size: 14px">&#12288;文件解析状态：</span>
      <el-select style="width:250px" clearable v-model="statusCode" size="small">
        <el-option
          v-for="item in statusList"
          :key="item.value"
          :label="item.label"
          :value="item.value">
          <span style="float: left">{{ item.label }}</span>
        </el-option>
      </el-select>
      &nbsp;&nbsp;
      <span style="font-weight: bold;font-size: 14px">&#12288;文件类型：</span>
      <el-select style="width:250px" clearable v-model="fileType" size="small">
        <el-option
          v-for="item in fileTypes"
          :key="item.label"
          :label="item.label"
          :value="item.label">
          <span style="float: left">{{ item.label }}</span>
        </el-option>
      </el-select>
      &nbsp;
      <div class="timeQuery" style="display: inline-block">
        <el-button size="small" :loading="loading" @click="dataQuery">查询</el-button>
      </div>
    </div>
    <basic-container>
      <avue-crud ref="crud"
                 :page.sync="page"
                 :data="tableData"
                 :table-loading="tableLoading"
                 :option="tableOption"
                 @on-load="dataQuery"
                 @search-change="searchChange"
                 @refresh-change="refreshChange"
                 @size-change="sizeChange"
                 @current-change="currentChange"
      >
      </avue-crud>
    </basic-container>
  </div>
</template>

<script>
import {
  getByStationCodeAndCreateTimeAndFileStatusAndFileType,
  getStation
} from '@/api/parsingLog'
import {tableOption} from '@/const/crud/parsingLog'
import {mapGetters} from 'vuex'

export default {
  name: 'parsingLog',
  data() {
    return {
      createDate: new Date(new Date().toLocaleDateString()).getTime(),
      stationList: [],
      stationCode: [],
      statusCode: [],
      searchForm: {},
      tableData: [],
      fileType: "",
      fileTypes: [{
        value: 0,
        label: '短期'
      }, {
        value: 1,
        label: '超短期'
      }, {
        value: 2,
        label: '测风塔'
      }, {
        value: 3,
        label: '气象站'
      }, {
        value: 4,
        label: 'NWP'
      }, {
        value: 5,
        label: '风机'
      }, {
        value: 6,
        label: '逆变器'
      }],
      statusList: [{
        value: 0,
        label: '失败'
      }, {
        value: 1,
        label: '成功'
      }],
      page: {
        total: 0, // 总页数
        currentPage: 1, // 当前页数
        pageSize: 20 // 每页显示多少条
      },
      tableLoading: false,
      tableOption: tableOption,
      loading: false,
    }
  },
  computed: {
    ...mapGetters(['permissions']),
  },
  mounted() {
    this.getStationCode()
  },
  methods: {
    getStationCode() {
      this.tableLoading = true
      getStation().then(response => {
        console.log(response.data.data)
        this.stationList = response.data.data
        this.tableLoading = false
      })
    },
    dataQuery() {
      this.tableLoading = true
      const param = new URLSearchParams()
      param.append('currentPage', this.page.currentPage)
      param.append('pageSize', this.page.pageSize)
      param.append('stationCode', this.stationCode)
      param.append('time', this.createDate)
      param.append('fileStatus', this.statusCode)
      param.append('fileType', this.fileType)
      getByStationCodeAndCreateTimeAndFileStatusAndFileType(param).then(response => {
        this.tableData = response.data.data.records
        this.page.total = response.data.data.total
        this.tableLoading = false
      }).catch(() => {
        this.tableLoading = false
      })
    },
    rowDel: function (row, index) {
      this.$confirm('是否确认删除ID为' + row.id, '提示', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(function () {
        return delObj(row.id)
      }).then(data => {
        this.$message.success('删除成功')
        this.dataQuery()
      })
    },
    handleUpdate: function (row, index, done, loading) {
      putObj(row).then(data => {
        this.$message.success('修改成功')
        done()
        this.dataQuery()
      }).catch(() => {
        loading();
      });
    },
    handleSave: function (row, done, loading) {
      addObj(row).then(data => {
        this.$message.success('添加成功')
        done()
        this.dataQuery()
      }).catch(() => {
        loading();
      });
    },
    sizeChange(pageSize) {
      this.page.pageSize = pageSize
    },
    currentChange(current) {
      this.page.currentPage = current
    },
    searchChange(form, done) {
      this.searchForm = form
      this.page.currentPage = 1
      this.dataQuery()
      done()
    },
    refreshChange() {
      this.dataQuery()
    }
  }
}
</script>
